// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef PARAM_FIELD_EVALUATOR_H
#define PARAM_FIELD_EVALUATOR_H

#include "field_evaluator.h"
#include "predict_state.h"

#include <vector>

namespace rcsc {
class AbstractPlayerObject;
class ActionStatePair;
class Vector2D;
}

class ParamFieldEvaluator
    : public rcsc::FieldEvaluator {
private:
    static
    double get_chain_length_penalty( const std::vector< rcsc::ActionStatePair > & path,
                                     const rcsc::PredictState & state );

    static
    double get_chain_evaluation( const rcsc::PredictState & state,
                                 const std::vector< rcsc::ActionStatePair > & path );

public:
    ParamFieldEvaluator();

    virtual
    ~ParamFieldEvaluator();

    static
    bool read_parameters( const std::string & prefix );


    virtual
    double operator()( const rcsc::PredictState & state,
                       const std::vector< rcsc::ActionStatePair > & path ) const;
public:
    static
    bool is_free_situation_near_offside_line( const rcsc::PredictState & wm,
                                              const rcsc::AbstractPlayerObject * from );
};

#endif
